[LeetCode] 160. Intersection of Two Linked Lists

Problem

Write a program to find the node at which the intersection of two singly linked lists begins.

For example, the following two linked lists:

160. Intersection of Two Linked Lists

begin to intersect at node c1.

Example 1:

160. Intersection of Two Linked Lists

1
2
3
Input: intersectVal = 8, listA = [4,1,8,4,5], listB = [5,0,1,8,4,5], skipA = 2, skipB = 3
Output: Reference of the node with value = 8
Input Explanation: The intersected node's value is 8 (note that this must not be 0 if the two lists intersect). From the head of A, it reads as [4,1,8,4,5]. From the head of B, it reads as [5,0,1,8,4,5]. There are 2 nodes before the intersected node in A; There are 3 nodes before the intersected node in B.

Example 2:

160. Intersection of Two Linked Lists

1
2
3
Input: intersectVal = 2, listA = [0,9,1,2,4], listB = [3,2,4], skipA = 3, skipB = 1
Output: Reference of the node with value = 2
Input Explanation: The intersected node's value is 2 (note that this must not be 0 if the two lists intersect). From the head of A, it reads as [0,9,1,2,4]. From the head of B, it reads as [3,2,4]. There are 3 nodes before the intersected node in A; There are 1 node before the intersected node in B.

Example 3:

160. Intersection of Two Linked Lists

1
2
3
4
Input: intersectVal = 0, listA = [2,6,4], listB = [1,5], skipA = 3, skipB = 2
Output: null
Input Explanation: From the head of A, it reads as [2,6,4]. From the head of B, it reads as [1,5]. Since the two lists do not intersect, intersectVal must be 0, while skipA and skipB can be arbitrary values.
Explanation: The two lists do not intersect, so return null.

Notes:

  • If the two linked lists have no intersection at all, return null.
  • The linked lists must retain their original structure after the function returns.
  • You may assume there are no cycles anywhere in the entire linked structure.
  • Your code should preferably run in O(n) time and use only O(1) memory.

Explanation 1

  1. We can start compaing using two pointers when both list have the same length, so we move forward diff steps on the long linked list’s pointer. Then iterate both pointer and compare each node.

Solution 1

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
/**
 * Definition for singly-linked list.
 * public class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode(int x) {
 *         val = x;
 *         next = null;
 *     }
 * }
 */
public class Solution {
    public int getLen(ListNode head) {
        int counter = 0;
        while (head != null) {
            head = head.next;
            counter += 1;
        }
        return counter;
    }

    public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
        int lenA = getLen(headA);
        int lenB = getLen(headB);
        ListNode ptrA = headA;
        ListNode ptrB = headB;
        if (lenA > lenB) {
            int diff = lenA - lenB;
            for (int i = 0; i < diff; i++) {
                ptrA = ptrA.next;
            }
        } else {
            for (int i = 0; i < lenB-lenA; i++) {
                ptrB = ptrB.next;
            }
        }

        while (ptrA != ptrB) {
            ptrA = ptrA.next;
            ptrB = ptrB.next;
        }

        return ptrA;
    }
}

Explanation 2

  1. When we finish iterating one list, we move that pointer start from the beginning of another list. When two pointers meet, that node is the intesection. Because both pointers run the same length, in other word, the sum of lenA and lenB doesn’t change.

Solution 2

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
/**
 * Definition for singly-linked list.
 * public class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode(int x) {
 *         val = x;
 *         next = null;
 *     }
 * }
 */
public class Solution {
    public int getLen(ListNode head) {
        int counter = 0;
        while (head != null) {
            head = head.next;
            counter += 1;
        }
        return counter;
    }

    public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
        if (headA == null || headB == null) return null;
        ListNode ptrA = headA;
        ListNode ptrB = headB;
        int lenA = getLen(headA);
        int lenB = getLen(headB);
        int counter = 0;
        while (ptrA != ptrB) {
            ptrA = ptrA.next;
            ptrB = ptrB.next;
            if (ptrA == null) ptrA = headB;
            if (ptrB == null) ptrB = headA;
            counter += 1;
            if (counter > lenA+lenB) return null;
        }
        return ptrA;
    }
}